import os
import sys

from Tkinter import *

import tkFileDialog
from pymol import cmd
#import ttk

os.environ['PYTHONPATH'] = (os.environ['PYTHONPATH'] + ":" + os.environ.get('HOME'))
if(os.path.exists(os.path.join(os.environ.get('HOME'), 'GRAPE_Path_File.py'))):
	import GRAPE_Path_File
else:
	temp = os.environ.get('HOME')
	FILE = open(os.path.join(temp, 'GRAPE_Path_File.py'), "w")
	FILE.writelines(["#this is the path file storage for the GRAPEMol_Plugin -- do not delete or edit\n", "GRAPEMolPath = None"])
	print "made a new path file"
	FILE.close()
	import GRAPE_Path_File

filePath = os.environ.get('HOME')

if(GRAPE_Path_File.GRAPEMolPath != None):
	if(os.path.split(GRAPE_Path_File.GRAPEMolPath)[1] == 'GRAPE_Main.py'):
		cmd.cd(os.path.split(GRAPE_Path_File.GRAPEMolPath)[0])
		import GRAPE_Main

def __init__(self):
	self.menuBar.addcascademenu('Plugin','GRAPE','GRAPE',label = 'GRAPE')
	self.menuBar.addmenuitem('GRAPE','command','start GRAPE', label = 'Start GRAPE',command = lambda s = self: LoadGRAPE(s))
	self.menuBar.addmenuitem('GRAPE','command','new GRAPE path', label = 'Set new GRAPE path', command = lambda s = self: ModifyGRAPEPath(s))
	self.GRAPE_running = False


def ModifyGRAPEPath(s):
	GRAPEMolPath = tkFileDialog.askopenfilename(defaultextension = '' ,
						initialdir = '/', initialfile = '' , parent = s.root, title = 'please specify GRAPE_Main Location')
	if(os.path.split(GRAPEMolPath)[1] == 'GRAPE_Main.py'):
		realpath = os.path.join(filePath, "GRAPE_Path_File.py")
		FILE = open(realpath, "w")
		FILE.writelines(["#this is the path file storage for the GRAPE_Plugin -- do not delete or edit\n", "GRAPEMolPath = '" + GRAPEMolPath + "'"])
		FILE.close()
		print "Please restart pymol to use the GRAPE plugin."
	else:
		print "Couldn't find GRAPE_Main.py - no path selected."

def LoadGRAPE(s):

	if(GRAPE_Path_File.GRAPEMolPath == None):
		ModifyGRAPEPath(s)
	if(GRAPE_Path_File.GRAPEMolPath != None and s.GRAPE_running == False):
		s.GRAPE_running = True
		if(os.path.split(GRAPE_Path_File.GRAPEMolPath)[1] == 'GRAPE_Main.py'):
			cmd.cd(os.path.split(GRAPE_Path_File.GRAPEMolPath)[0])
			wiim = GRAPE_Main.GRAPE()
			GRAPE_Main.GRAPE.startTk(wiim, None)


cmd.extend('loadGRAPE',LoadGRAPE)
